<?php
/**
 * @package Millioneyez
 * @version 2.2.5
 */
/*
Plugin Name: million eyez
Plugin URI: http://www.millioneyez.com/plugin/
Description: The million eyez plugin enables writers and photographers to interact in a novel way to co-produce visually rich stories. Gain new sources of imagery to enhance your content and increase engagement.
Author: million eyez
Version: 2.2.5
Author URI: http://www.millioneyez.com/

*/

$millioneyez_plugin_version = '2.2.5';

require_once 'global_settings.php';
require_once 'post_meta_box.php';
require_once 'content.php';

add_filter( 'plugin_action_links', 'millioneyez_plugin_action_links', 10, 2 );
add_action( 'init', 'millioneyez_settings_add_defaults' );

function millioneyez_settings_add_defaults() {
    $options = get_option('millioneyez_options');
    $optionsArray = array(
        "key" => "",
        "secret" => "",
        "featured" => 0,
        "featuredType" => "responsive",
        "hideFeatured" => 0,
        "hideVia" => "false",
        "default_post_component_state" => "hidden",
        "component_size" => "full_width",
        "remove_shortcodes_from_the_excerpt" => 1
    );

    foreach($optionsArray as $key => $value) {
        if (!isset($options[$key])) {
            $options[$key] = $value;
        }
    }

    update_option('millioneyez_options', $options);
}

// Display a Settings link on the main Plugins page
function millioneyez_plugin_action_links( $links, $file ) {

	if ( $file == plugin_basename( __FILE__ ) ) {
		$millioneyez_links = '<a href="'.get_admin_url().'admin.php?page=millioneyez_settings">'.__('Settings').'</a>';
		// make the 'Settings' link appear first
		array_unshift( $links, $millioneyez_links );
	}

	return $links;
}

?>
